import re
import cPickle
import os

VENDOR_ID_REGEX = re.compile('^vendor_id\s+: (\S+)')
GPU_LOCK_NO_SCRIPT = -2
GPU_LOCK_NO_LOCK = -1

def get_gpu_lock():
    import imp
    lock_script_path = '/u/murray/bin/gpu_lock.py'
    if os.path.exists(lock_script_path):
        locker = imp.load_source("", lock_script_path)
        return locker.obtain_lock_id()
    return GPU_LOCK_NO_SCRIPT

def pickle(file, data):
    fo = open(file, "wb")
    cPickle.dump(data, fo, protocol = cPickle.HIGHEST_PROTOCOL)
    fo.close()
    
def unpickle(file):
    fo = open(file, 'rb')
    dict = cPickle.load(fo)
    fo.close()
    return dict

def tryint(s):
    try:
        return int(s)
    except:
        return s

def alphanum_key(s):
    """ Turn a string into a list of string and number chunks.
        "z23a" -> ["z", 23, "a"]
    """
    return [ tryint(c) for c in re.split('([0-9]+)', s) ]

def is_intel_machine():
    f = open('/proc/cpuinfo')
    for line in f:
        m = VENDOR_ID_REGEX.match(line)
        if m:
            f.close()
            return m.group(1) == 'GenuineIntel'
    f.close()
    return False